-- =============================================
-- Author:		<Luca,,C6Mart.DM_GestioneEmail>
-- Create date: <13/11/2008,,>
-- Description:	<Prima fase popolamento tabella email,,>
-- =============================================
CREATE procedure [C6Mart].[DM_GestioneEmail] 
AS
BEGIN
BEGIN TRANSACTION
--QUESTA SP POPOLA LA TABELLA GESTIONE_EMAIL PER LE CASISTICHE DI:
--	PERFEZIONAMENTO;
--	MANCATA MIGRAZIONE;
--	REINVIO SOLLECITO MANCATA MIGRAZIONE.
--LA GESTIONE DELLE EMAIL PER LE RISORSE NON ASSOCIATE AD AREE DI BISOGNO O
--PER REINVIO DEL SOLLECITO PER LE RISORSE NON ASSOCIATE AD AREE DI BISOGNO 
--VIENE FATTA DOPO L'ALLINEAMENTO CON I DATI DEL SIMPB
--ESTRAZIONE EMAIL PERFEZIONAMENTO
--TIPO EMAIL: "PERF"
--L'EMAIL VIENE INVIATA PER TUTTI I CLIENTI CHE HANNO DATA DI PERFEZIONAMENTO VALORIZZATA
--IL CONTROLLO SULLA DATA DI GENERAZIONE >= DELLA DATA DI PERFEZIONAMENTO E' DOVUTO AL
--FATTO CHE IL CONTRATTO PUO` ESSERE CHIUSO E RIAPERTO ED IN QUESTO CASO LA MAIL DI PERFEZIONAMENTO
--DEVE ESSERE REINVIATA
-- EMAIL DI ADESIONE AL SERVIZIO SEI
-- TIPO EMAIL 'PERF'
DECLARE @NUMGIORNIDALPERF SMALLINT
DECLARE @NUMGIORNIDASOLLECITO SMALLINT
DECLARE @ID_ELAB INT
DECLARE @MaxInvioSoll as SMALLINT
SET @MaxInvioSoll = CAST(dbo.getParametro('MaxInvioSoll') as smallint)
SET @ID_ELAB = C6MART.GETIDELAB()
SET @NUMGIORNIDALPERF = CAST(dbo.getParametro('NUMGIORNIDALPERF') as smallint) --7
SET @NUMGIORNIDASOLLECITO = CAST(dbo.getParametro('NUMGIORNIDASOLLECITO') as smallint) --7
-- Log esecuzione
INSERT INTO LOG_ESECUZIONE
	(Nome, Inizio, Nota)
VALUES (
	'DM_GestioneEmail',
	GETDATE(),
	'Elaborazione giornaliera'
)
--1. INSERIMENTO MAIL DI "PERFEZIONAMENTO"
-- TUPLE DA PERFEZIONARE SU CONTRATTOSEI
-- NON PRESENTI SU GESTIONE_EMAIL
INSERT INTO C6Mart.GESTIONE_EMAIL
	(Rete,Cod_Fiscale,Tipo,Data_Generazione, ID_ELAB)
SELECT 
	C6.Rete,
	C6.Cod_Fiscale,
	'PERF' as TipoEmail,
	GETDATE() AS DataGenerazione,
	@ID_ELAB AS ID_ELAB
FROM C6Mart.ContrattoSEI C6
LEFT JOIN C6Mart.GESTIONE_EMAIL EMAIL
	ON C6.RETE = EMAIL.RETE
	AND C6.COD_FISCALE = EMAIL.COD_FISCALE
	AND EMAIL.TIPO = 'PERF'						
	AND EMAIL.Data_Generazione >= C6.Data_Perf	-- CONDIZIONE PER ESCLUDERE DAL JOIN UN CONTRATTO CHIUSO E RIAPERTO.
LEFT JOIN C6MART.CODICI_PROMOTORI_FITTIZI PF	-- IN QUESTO MODO LO INSERIAMO NUOVAMENTE IN GESTIONE_MAIL.
	ON C6.COD_AGENTE BETWEEN PF.CODICEDA AND PF.CODICEA
	AND C6.RETE = PF.RETE
WHERE 1 = 1
	--AND C6.InvioBenvenuto = 'N'
	AND C6.Data_FineAvanzato IS NULL
	--AND C6.GenerazioneReport = 'S'
	AND EMAIL.COD_FISCALE IS NULL
	AND PF.RETE IS NULL
-- Log esecuzione
UPDATE
	LOG_ESECUZIONE
SET
	Fine = GETDATE(),
	Tipo = 'INSERT',
	Righe = @@ROWCOUNT
WHERE
	Nome = 'DM_GestioneEmail' AND
	Inizio = (
		SELECT
			MAX(Inizio)
		FROM
			LOG_ESECUZIONE
		WHERE
			Nome = 'DM_GestioneEmail'
	)
INSERT INTO LOG_ESECUZIONE
	(Nome, Inizio, Nota)
VALUES (
	'DM_GestioneEmail',
	GETDATE(),
	'Elaborazione giornaliera'
)
-- 2. INSERIMENTO MAIL "SOLLECITI"
-- TUPLE DA PERFEZIONARE SU CONTRATTOSEI
-- E PRESENTI SU GESTIONE_EMAIL
-- IL PB NON HA EFFETTUATO LA MIGRAZIONE
-- N.B. PER IL PRIMO SOLLECITO DATA_ULTIMOSOLLECITO è NULL -> CONSIDERIAMO DATA_PERF
INSERT INTO C6Mart.GESTIONE_EMAIL
	(Rete,Cod_Fiscale,Tipo,Data_Generazione,ID_ELAB)
SELECT 
	C6.rete,
	C6.cod_fiscale,
	CASE 
		WHEN ISNULL(numSolleciti,0) = 0 THEN '1_SOLL_NOMIG'
		WHEN numSolleciti = 1 THEN '2_SOLL_NOMIG'
		WHEN numSolleciti = 2 THEN '3_SOLL_NOMIG'
		ELSE 'S_SOLL_NOMIG'
	END as tipoEmail,
	getDate() as DataGenerazione,
	@ID_ELAB AS ID_ELAB
FROM c6mart.contrattosei C6 
LEFT JOIN C6MART.CODICI_PROMOTORI_FITTIZI PF
	ON C6.COD_AGENTE BETWEEN PF.CODICEDA AND PF.CODICEA
	AND C6.RETE = PF.RETE
WHERE 1 = 1
	AND numSolleciti < @MaxInvioSoll
	AND (
			(ISNULL(numSolleciti,0) = 0 AND DATEDIFF(DAY,C6.Data_Perf,GETDATE()) >= @NUMGIORNIDALPERF)
			 OR
			(DATEDIFF(DAY,isnull(C6.Data_UltimoSollecito,GETDATE()),GETDATE()) >= @NUMGIORNIDASOLLECITO)
		)
	AND c6.clienteMigrato = 'N'
	AND c6.InvioBenvenuto = 'N' -- richiesto da Tringali per non inviare mail se report già inviato
	AND C6.Data_FineAvanzato IS NULL
	--AND C6.GenerazioneReport = 'S'
	AND PF.RETE IS NULL
-- Log esecuzione
UPDATE
	LOG_ESECUZIONE
SET
	Fine = GETDATE(),
	Tipo = 'INSERT',
	Righe = @@ROWCOUNT
WHERE
	Nome = 'DM_GestioneEmail' AND
	Inizio = (
		SELECT
			MAX(Inizio)
		FROM
			LOG_ESECUZIONE
		WHERE
			Nome = 'DM_GestioneEmail'
	)
INSERT INTO LOG_ESECUZIONE
	(Nome, Inizio, Nota)
VALUES (
	'DM_GestioneEmail',
	GETDATE(),
	'Elaborazione giornaliera'
)
-- 2.BIS UPDATE CONTRATTOSEI DOPO INSERIMENTO MAIL "SOLLECITI"
-- AUMENTIAMO IL NUMERO numSolleciti
-- AGGIORNIAMO LA DATA Data_UltimoSollecito
UPDATE 
	c6mart.contrattosei
SET 
	numSolleciti = isnull(numSolleciti,0) + 1,
	Data_UltimoSollecito = getDate()
FROM c6mart.contrattosei C6 
LEFT JOIN C6MART.CODICI_PROMOTORI_FITTIZI PF
	ON C6.COD_AGENTE BETWEEN PF.CODICEDA AND PF.CODICEA
	AND C6.RETE = PF.RETE
WHERE 1 = 1
	AND numSolleciti < @MaxInvioSoll
	AND (
			(ISNULL(numSolleciti,0) = 0 AND DATEDIFF(DAY,C6.Data_Perf,GETDATE()) >= @NUMGIORNIDALPERF)
			 OR
			(DATEDIFF(DAY,isnull(C6.Data_UltimoSollecito,GETDATE()),GETDATE()) >= @NUMGIORNIDASOLLECITO)
		)
	AND c6.clienteMigrato = 'N'
	AND c6.InvioBenvenuto = 'N' -- richiesto da Tringali per non inviare mail se report già inviato
	AND C6.Data_FineAvanzato IS NULL
	--AND C6.GenerazioneReport = 'S'
	AND PF.RETE IS NULL
-- Log esecuzione
UPDATE
	LOG_ESECUZIONE
SET
	Fine = GETDATE(),
	Tipo = 'UPDATE',
	Righe = @@ROWCOUNT
WHERE
	Nome = 'DM_GestioneEmail' AND
	Inizio = (
		SELECT
			MAX(Inizio)
		FROM
			LOG_ESECUZIONE
		WHERE
			Nome = 'DM_GestioneEmail'
	)
INSERT INTO LOG_ESECUZIONE
	(Nome, Inizio, Nota)
VALUES (
	'DM_GestioneEmail',
	GETDATE(),
	'Elaborazione giornaliera'
)
-- 3. INSERIMENTO MAIL "REVOCA"
-- TUPLE DA PERFEZIONARE SU CONTRATTOSEI
-- E PRESENTI SU GESTIONE_EMAIL
-- IL PB NON HA EFFETTUATO LA MIGRAZIONE DOPO @MaxInvioSoll SOLLECITI
-- N.B. OCCHIO ALLA CONDIZIONE -> (c6.clienteMigrato = 'N' AND numSolleciti = @MaxInvioSoll) OR  numSolleciti > @MaxInvioSoll
--		OVVERO: BUONA LA MIGRAZIONE EFFETTUATA DOPO L'ULTIMO SOLLECITO MA NON DOPO LA PRIMA REVOCA
INSERT INTO C6Mart.GESTIONE_EMAIL
	(Rete,Cod_Fiscale,Tipo,Data_Generazione,ID_ELAB)
SELECT  
	email.rete,
	email.cod_fiscale,
	'REVOCA_NOMIG' as tipoEmail,
	getDate() as DataGenerazione,
	@ID_ELAB AS ID_ELAB --max(Data_Generazione)
FROM c6mart.contrattosei c6 
INNER JOIN c6mart.gestione_Email EMAIL
	ON C6.RETE = EMAIL.RETE
	AND C6.COD_FISCALE = EMAIL.COD_FISCALE
LEFT JOIN C6MART.CODICI_PROMOTORI_FITTIZI PF
	ON C6.COD_AGENTE BETWEEN PF.CODICEDA AND PF.CODICEA
	AND C6.RETE = PF.RETE
WHERE 1 = 1
	AND EMAIL.Tipo IN ('S_SOLL_NOMIG','REVOCA_NOMIG')	
	AND (
			(numRevoche> 0) -- SONO NEL CASO DI REVOCA SUCCESSIVA BRAVO VALERIO
			OR 
			(numSolleciti = @MaxInvioSoll and C6.clienteMigrato = 'N')-- SONO NEL CASO DI PRIMA REVOCA
		)
	AND C6.Data_FineAvanzato IS NULL
	--AND C6.GenerazioneReport = 'S'
	AND (DATEDIFF(DAY,isnull(C6.Data_UltimaRevoca,C6.Data_UltimoSollecito),GETDATE()) >= @NUMGIORNIDASOLLECITO)
	AND PF.RETE IS NULL
GROUP BY email.rete, email.cod_fiscale
-- Log esecuzione
UPDATE
	LOG_ESECUZIONE
SET
	Fine = GETDATE(),
	Tipo = 'INSERT',
	Righe = @@ROWCOUNT
WHERE
	Nome = 'DM_GestioneEmail' AND
	Inizio = (
		SELECT
			MAX(Inizio)
		FROM
			LOG_ESECUZIONE
		WHERE
			Nome = 'DM_GestioneEmail'
	)
INSERT INTO LOG_ESECUZIONE
	(Nome, Inizio, Nota)
VALUES (
	'DM_GestioneEmail',
	GETDATE(),
	'Elaborazione giornaliera'
)
-- 3.BIS UPDATE CONTRATTOSEI DOPO INSERIMENTO MAIL "REVOCA"
-- AUMENTIAMO IL NUMERO numSolleciti
-- NON AGGIORNIAMO LA DATA Data_UltimoSollecito
-- N.B. VERIFICARE SE IL CAMPO Data_UltimoSollecito VA AGGIORNATO
UPDATE c6mart.contrattosei
SET 
	numRevoche = isnull(numRevoche,0) + 1,
	data_UltimaRevoca = getDate()
FROM c6mart.contrattosei c6 
INNER JOIN c6mart.gestione_Email EMAIL
	ON C6.RETE = EMAIL.RETE
	AND C6.COD_FISCALE = EMAIL.COD_FISCALE
LEFT JOIN C6MART.CODICI_PROMOTORI_FITTIZI PF
	ON C6.COD_AGENTE BETWEEN PF.CODICEDA AND PF.CODICEA
	AND C6.RETE = PF.RETE
WHERE 1 = 1
	AND EMAIL.Tipo IN ('S_SOLL_NOMIG','REVOCA_NOMIG')	
	AND (
			(numRevoche> 0) -- SONO NEL CASO DI REVOCA SUCCESSIVA BRAVO VALERIO
			OR 
			(numSolleciti = @MaxInvioSoll and C6.clienteMigrato = 'N')-- SONO NEL CASO DI PRIMA REVOCA
		)
	AND C6.Data_FineAvanzato IS NULL
	--AND C6.GenerazioneReport = 'S'
	AND (DATEDIFF(DAY,isnull(C6.Data_UltimaRevoca,C6.Data_UltimoSollecito),GETDATE()) >= @NUMGIORNIDASOLLECITO)
	AND PF.RETE IS NULL
-- Log esecuzione
UPDATE
	LOG_ESECUZIONE
SET
	Fine = GETDATE(),
	Tipo = 'UPDATE',
	Righe = @@ROWCOUNT
WHERE
	Nome = 'DM_GestioneEmail' AND
	Inizio = (
		SELECT
			MAX(Inizio)
		FROM
			LOG_ESECUZIONE
		WHERE
			Nome = 'DM_GestioneEmail'
	)
COMMIT
END